"use strict";
/**
 * Copyright 2018, OpenCensus Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const metric_registry_1 = require("./metric-registry");
class Metrics {
    /**
     * Returns the global MetricRegistry.
     *
     * @return {MetricRegistry}.
     */
    static getMetricRegistry() {
        return Metrics.METRIC_REGISTRY;
    }
    static newMetricRegistry() {
        return new metric_registry_1.MetricRegistry();
    }
}
Metrics.METRIC_REGISTRY = Metrics.newMetricRegistry();
exports.Metrics = Metrics;
//# sourceMappingURL=metrics.js.map